---
apiVersion: v1
kind: ConfigMap
metadata:
  labels:
    app: rest-heroes
    application: heroes-service
    system: quarkus-super-heroes
  name: rest-heroes-config
data:
  quarkus.hibernate-orm.database.generation: validate
  quarkus.hibernate-orm.sql-load-script: no-file
  quarkus.datasource.reactive.url: postgresql://heroes-db:5432/heroes_database
  quarkus.opentelemetry.tracer.exporter.otlp.endpoint: http://otel-collector:4317
---
apiVersion: v1
kind: Secret
metadata:
  labels:
    app: rest-heroes
    application: heroes-service
    system: quarkus-super-heroes
  name: rest-heroes-config-creds
data:
  quarkus.datasource.username: c3VwZXJtYW4=
  quarkus.datasource.password: c3VwZXJtYW4=
type: Opaque
---
apiVersion: v1
kind: Secret
metadata:
  labels:
    app: heroes-db
    application: heroes-service
    system: quarkus-super-heroes
  name: heroes-db-config
data:
  POSTGRESQL_DATABASE: aGVyb2VzX2RhdGFiYXNl
  POSTGRESQL_USERNAME: c3VwZXJtYW4=
  POSTGRESQL_PASSWORD: c3VwZXJtYW4=
type: Opaque
---
apiVersion: v1
kind: ConfigMap
metadata:
  labels:
    app: heroes-db
    application: heroes-service
    system: quarkus-super-heroes
  name: heroes-db-init
data:
  get-data.sh: |-
    #!/bin/bash

    curl https://raw.githubusercontent.com/quarkusio/quarkus-super-heroes/main/rest-heroes/deploy/db-init/initialize-tables.sql --output /docker-entrypoint-initdb.d/1-init-tables.sql
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: heroes-db
    application: heroes-service
    system: quarkus-super-heroes
    app.kubernetes.io/part-of: heroes-service
    app.openshift.io/runtime: postgresql
  name: heroes-db
spec:
  replicas: 1
  selector:
    matchLabels:
      name: heroes-db
  template:
    metadata:
      labels:
        name: heroes-db
        application: heroes-service
        system: quarkus-super-heroes
    spec:
      containers:
        - envFrom:
            - secretRef:
                name: heroes-db-config
          image: bitnami/postgresql:14
          name: heroes-db
          ports:
            - containerPort: 5432
          resources:
            limits:
              memory: 128Mi
            requests:
              memory: 32Mi
          volumeMounts:
            - mountPath: /bitnami/postgresql
              name: heroes-db-data
            - mountPath: /docker-entrypoint-initdb.d
              name: heroes-db-init-data
      initContainers:
        - command:
            - sh
            - get-data.sh
          image: registry.access.redhat.com/ubi8-minimal:8.6
          name: get-data
          volumeMounts:
            - mountPath: /docker-entrypoint-preinitdb.d
              name: heroes-db-init
            - mountPath: /docker-entrypoint-initdb.d
              name: heroes-db-init-data
          workingDir: /docker-entrypoint-preinitdb.d
      volumes:
        - emptyDir: {}
          name: heroes-db-data
        - emptyDir: {}
          name: heroes-db-init-data
        - configMap:
            name: heroes-db-init
          name: heroes-db-init
---
apiVersion: v1
kind: Service
metadata:
  labels:
    name: heroes-db
    application: heroes-service
    system: quarkus-super-heroes
  name: heroes-db
spec:
  ports:
    - port: 5432
      protocol: TCP
      targetPort: 5432
  selector:
    name: heroes-db
  type: ClusterIP
---
apiVersion: apps/v1
kind: Deployment
metadata:
  annotations:
    app.quarkus.io/vcs-ref: main
    app.quarkus.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
    app.openshift.io/connects-to: "heroes-db,otel-collector"
    app.quarkus.io/build-timestamp: 2022-11-14 - 19:50:25 +0000
    prometheus.io/scrape: "true"
    prometheus.io/path: /q/metrics
    prometheus.io/port: "8083"
    prometheus.io/scheme: http
  labels:
    app.kubernetes.io/name: rest-heroes
    app.kubernetes.io/part-of: heroes-service
    app.kubernetes.io/version: java17-latest
    app: rest-heroes
    application: heroes-service
    system: quarkus-super-heroes
  name: rest-heroes
spec:
  replicas: 1
  selector:
    matchLabels:
      app.kubernetes.io/name: rest-heroes
      app.kubernetes.io/part-of: heroes-service
      app.kubernetes.io/version: java17-latest
  template:
    metadata:
      annotations:
        app.quarkus.io/vcs-ref: main
        app.quarkus.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
        app.openshift.io/connects-to: "heroes-db,otel-collector"
        app.quarkus.io/build-timestamp: 2022-11-14 - 19:50:25 +0000
        prometheus.io/scrape: "true"
        prometheus.io/path: /q/metrics
        prometheus.io/port: "8083"
        prometheus.io/scheme: http
      labels:
        app.kubernetes.io/name: rest-heroes
        app.kubernetes.io/part-of: heroes-service
        app.kubernetes.io/version: java17-latest
        app: rest-heroes
        application: heroes-service
        system: quarkus-super-heroes
    spec:
      containers:
        - env:
            - name: KUBERNETES_NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
          envFrom:
            - configMapRef:
                name: rest-heroes-config
            - secretRef:
                name: rest-heroes-config-creds
          image: quay.io/quarkus-super-heroes/rest-heroes:java17-latest
          imagePullPolicy: IfNotPresent
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /q/health/live
              port: 8083
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          name: rest-heroes
          ports:
            - containerPort: 8083
              name: http
              protocol: TCP
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /q/health/ready
              port: 8083
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          resources:
            limits:
              memory: 768Mi
            requests:
              memory: 256Mi
---
apiVersion: v1
kind: Service
metadata:
  annotations:
    app.quarkus.io/vcs-ref: main
    app.quarkus.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
    app.openshift.io/connects-to: "heroes-db,otel-collector"
    app.quarkus.io/build-timestamp: 2022-11-14 - 19:50:25 +0000
    prometheus.io/scrape: "true"
    prometheus.io/path: /q/metrics
    prometheus.io/port: "8083"
    prometheus.io/scheme: http
  labels:
    app.kubernetes.io/name: rest-heroes
    app.kubernetes.io/part-of: heroes-service
    app.kubernetes.io/version: java17-latest
    app: rest-heroes
    application: heroes-service
    system: quarkus-super-heroes
  name: rest-heroes
spec:
  ports:
    - name: http
      nodePort: 30471
      port: 80
      protocol: TCP
      targetPort: 8083
  selector:
    app.kubernetes.io/name: rest-heroes
    app.kubernetes.io/part-of: heroes-service
    app.kubernetes.io/version: java17-latest
  type: NodePort
